> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.feedonomics.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.feedonomics.com/_mcp/server.

# Update details of a fulfillment

PUT https://api.feedamp.feedonomics.com/api/v2/orders/{order-id}/fulfillments/{fulfillment-id}
Content-Type: application/json

Update the details of the specified fulfillment in the specified order

Reference: https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/fulfillments/put-fulfillment

## Request

### Path parameters

- `order-id` (string, required) — FeedAMP Order ID
- `fulfillment-id` (string, required) — FeedAMP Fulfillment ID

### Headers

- `token` (string, required) — The Authentication token obtained from the v1 get_token route
- `client` (integer, required) — The ID of the client making the request

### Body (application/json)

This endpoint expects a Fulfillment.

- `Fulfillment`
  - Shipment: Shipment
  - LocalDelivery: LocalDelivery
  - Pickup: Pickup

## Response

### 200

The complete fulfillment object

- `id` (string, required) — Unique identifier for a record
- `fulfillment_lines` (list of LineQuantity, required) — Specification of order lines and quantities contained in the shipment

## Errors

### 400 Bad Request Error

Validation error detected when creating/updating a record

- `error` (string, required)

### 401 Unauthorized Error

Error validating credentials or access to resources.

- `error` (string, required)

### 404 Not Found Error

Requested order or fulfillment does not exist

- `any`

### 500 Internal Server Error

An unexpected server error occurred. Please contact Feedonomics Support if error persists.

- `error` (string, required)

### 503 Service Unavailable Error

Server is temporarily unable to handle the request

- `error` (string, required)

## Types

### Shipment

- `fulfillment_type` (enum, required)
  - Allowed values: `shipment`
- `shipment` (ShipmentShipment, required)
- `state` (enum, optional)
  - Allowed values: `shipped`

### LocalDelivery

- `fulfillment_type` (enum, required)
  - Allowed values: `local_delivery`
- `local_delivery` (LocalDeliveryLocalDelivery, optional)
- `state` (enum, optional)
  - Allowed values: `ready_for_pickup`, `picked_up`, `delivered`

### Pickup

- `fulfillment_type` (enum, required)
  - Allowed values: `pickup`
- `pickup` (PickupPickup, optional)
- `state` (enum, optional)
  - Allowed values: `ready_for_pickup`, `picked_up`

### LineQuantity

Specification of an order line number and quantity for that line

- `line_id` (string, required) — Unique identifier for a record
- `quantity` (integer, required)

### ShipmentShipment

- `shipped_date` (datetime, required) — Date and time the shipment was created. RFC-3339 format 2020-12-31T12:34:56-05:00
- `carrier` (string, required) — Carrier used by seller for shipping. Any string will be accepted, see examples for preferred spellings of common carriers.
- `tracking_number` (string, required) — Tracking number provided by Carrier for the shipment
- `tracking_url` (string, optional)

### LocalDeliveryLocalDelivery

- `delivery_id` (string, optional) — An ID string or tracking number that uniquely identifies the delivery
- `delivery_date` (any, optional) — Date and time the delivery created or the status was updated. RFC-3339 format 2020-12-31T12:34:56-05:00

### PickupPickup

## Examples

**Request**

```json
{
  "fulfillment_type": "shipment",
  "shipment": {
    "carrier": " '4PX', 'A-1', 'AAA Cooper', 'ABF', 'Asendia', 'Best Buy', 'Blue Package', 'Canada Post', 'CEVA', 'China Post', 'Conway', 'DHL', 'DHL eCommerce', 'Estes', 'FedEx', 'Fedex Freight', 'FedEx SmartPost', 'First Mile', 'Hongkong Post', 'Hunter Logistics', 'India Post', 'JCEX', 'Lasership', 'Newgistics', 'Old Dominion', 'OnTrac', 'OSM', 'Pilot Freight', 'R+L', 'Roadrunner', 'Royal Mail', 'Saia', 'SF Express', 'SFC', 'Singapore Post', 'South Eastern Freight Lines', 'Streamlite', 'UPS', 'UPS Freight', 'UPS Mail Innovations', 'Urban Express', 'USPS', 'WanbExpress', 'Watkins and Shepard', 'YANWEN', 'Yellow Freight', 'Yun Express', 'Other'",
    "shipped_date": {},
    "tracking_number": "string"
  }
}
```

**Response**

```json
{
  "id": "109872189273617283",
  "fulfillment_lines": [
    {
      "line_id": "109872189273617283",
      "quantity": 1
    }
  ],
  "fulfillment_type": "shipment",
  "shipment": {
    "carrier": " '4PX', 'A-1', 'AAA Cooper', 'ABF', 'Asendia', 'Best Buy', 'Blue Package', 'Canada Post', 'CEVA', 'China Post', 'Conway', 'DHL', 'DHL eCommerce', 'Estes', 'FedEx', 'Fedex Freight', 'FedEx SmartPost', 'First Mile', 'Hongkong Post', 'Hunter Logistics', 'India Post', 'JCEX', 'Lasership', 'Newgistics', 'Old Dominion', 'OnTrac', 'OSM', 'Pilot Freight', 'R+L', 'Roadrunner', 'Royal Mail', 'Saia', 'SF Express', 'SFC', 'Singapore Post', 'South Eastern Freight Lines', 'Streamlite', 'UPS', 'UPS Freight', 'UPS Mail Innovations', 'Urban Express', 'USPS', 'WanbExpress', 'Watkins and Shepard', 'YANWEN', 'Yellow Freight', 'Yun Express', 'Other'",
    "shipped_date": {},
    "tracking_number": "string",
    "tracking_url": "string"
  },
  "state": "shipped"
}
```

**SDK Code**

```python
import requests

url = "https://api.feedamp.feedonomics.com/api/v2/orders/109872189273617283/fulfillments/109872189273617283"

payload = {
    "fulfillment_type": "shipment",
    "shipment": {
        "carrier": " '4PX', 'A-1', 'AAA Cooper', 'ABF', 'Asendia', 'Best Buy', 'Blue Package', 'Canada Post', 'CEVA', 'China Post', 'Conway', 'DHL', 'DHL eCommerce', 'Estes', 'FedEx', 'Fedex Freight', 'FedEx SmartPost', 'First Mile', 'Hongkong Post', 'Hunter Logistics', 'India Post', 'JCEX', 'Lasership', 'Newgistics', 'Old Dominion', 'OnTrac', 'OSM', 'Pilot Freight', 'R+L', 'Roadrunner', 'Royal Mail', 'Saia', 'SF Express', 'SFC', 'Singapore Post', 'South Eastern Freight Lines', 'Streamlite', 'UPS', 'UPS Freight', 'UPS Mail Innovations', 'Urban Express', 'USPS', 'WanbExpress', 'Watkins and Shepard', 'YANWEN', 'Yellow Freight', 'Yun Express', 'Other'",
        "shipped_date": {},
        "tracking_number": "string"
    }
}
headers = {
    "client": "1",
    "token": "token",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.feedamp.feedonomics.com/api/v2/orders/109872189273617283/fulfillments/109872189273617283';
const options = {
  method: 'PUT',
  headers: {client: '1', token: 'token', 'Content-Type': 'application/json'},
  body: '{"fulfillment_type":"shipment","shipment":{"carrier":" \'4PX\', \'A-1\', \'AAA Cooper\', \'ABF\', \'Asendia\', \'Best Buy\', \'Blue Package\', \'Canada Post\', \'CEVA\', \'China Post\', \'Conway\', \'DHL\', \'DHL eCommerce\', \'Estes\', \'FedEx\', \'Fedex Freight\', \'FedEx SmartPost\', \'First Mile\', \'Hongkong Post\', \'Hunter Logistics\', \'India Post\', \'JCEX\', \'Lasership\', \'Newgistics\', \'Old Dominion\', \'OnTrac\', \'OSM\', \'Pilot Freight\', \'R+L\', \'Roadrunner\', \'Royal Mail\', \'Saia\', \'SF Express\', \'SFC\', \'Singapore Post\', \'South Eastern Freight Lines\', \'Streamlite\', \'UPS\', \'UPS Freight\', \'UPS Mail Innovations\', \'Urban Express\', \'USPS\', \'WanbExpress\', \'Watkins and Shepard\', \'YANWEN\', \'Yellow Freight\', \'Yun Express\', \'Other\'","shipped_date":{},"tracking_number":"string"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.feedamp.feedonomics.com/api/v2/orders/109872189273617283/fulfillments/109872189273617283"

	payload := strings.NewReader("{\n  \"fulfillment_type\": \"shipment\",\n  \"shipment\": {\n    \"carrier\": \" '4PX', 'A-1', 'AAA Cooper', 'ABF', 'Asendia', 'Best Buy', 'Blue Package', 'Canada Post', 'CEVA', 'China Post', 'Conway', 'DHL', 'DHL eCommerce', 'Estes', 'FedEx', 'Fedex Freight', 'FedEx SmartPost', 'First Mile', 'Hongkong Post', 'Hunter Logistics', 'India Post', 'JCEX', 'Lasership', 'Newgistics', 'Old Dominion', 'OnTrac', 'OSM', 'Pilot Freight', 'R+L', 'Roadrunner', 'Royal Mail', 'Saia', 'SF Express', 'SFC', 'Singapore Post', 'South Eastern Freight Lines', 'Streamlite', 'UPS', 'UPS Freight', 'UPS Mail Innovations', 'Urban Express', 'USPS', 'WanbExpress', 'Watkins and Shepard', 'YANWEN', 'Yellow Freight', 'Yun Express', 'Other'\",\n    \"shipped_date\": {},\n    \"tracking_number\": \"string\"\n  }\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("client", "1")
	req.Header.Add("token", "token")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.feedamp.feedonomics.com/api/v2/orders/109872189273617283/fulfillments/109872189273617283")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["client"] = '1'
request["token"] = 'token'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"fulfillment_type\": \"shipment\",\n  \"shipment\": {\n    \"carrier\": \" '4PX', 'A-1', 'AAA Cooper', 'ABF', 'Asendia', 'Best Buy', 'Blue Package', 'Canada Post', 'CEVA', 'China Post', 'Conway', 'DHL', 'DHL eCommerce', 'Estes', 'FedEx', 'Fedex Freight', 'FedEx SmartPost', 'First Mile', 'Hongkong Post', 'Hunter Logistics', 'India Post', 'JCEX', 'Lasership', 'Newgistics', 'Old Dominion', 'OnTrac', 'OSM', 'Pilot Freight', 'R+L', 'Roadrunner', 'Royal Mail', 'Saia', 'SF Express', 'SFC', 'Singapore Post', 'South Eastern Freight Lines', 'Streamlite', 'UPS', 'UPS Freight', 'UPS Mail Innovations', 'Urban Express', 'USPS', 'WanbExpress', 'Watkins and Shepard', 'YANWEN', 'Yellow Freight', 'Yun Express', 'Other'\",\n    \"shipped_date\": {},\n    \"tracking_number\": \"string\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://api.feedamp.feedonomics.com/api/v2/orders/109872189273617283/fulfillments/109872189273617283")
  .header("client", "1")
  .header("token", "token")
  .header("Content-Type", "application/json")
  .body("{\n  \"fulfillment_type\": \"shipment\",\n  \"shipment\": {\n    \"carrier\": \" '4PX', 'A-1', 'AAA Cooper', 'ABF', 'Asendia', 'Best Buy', 'Blue Package', 'Canada Post', 'CEVA', 'China Post', 'Conway', 'DHL', 'DHL eCommerce', 'Estes', 'FedEx', 'Fedex Freight', 'FedEx SmartPost', 'First Mile', 'Hongkong Post', 'Hunter Logistics', 'India Post', 'JCEX', 'Lasership', 'Newgistics', 'Old Dominion', 'OnTrac', 'OSM', 'Pilot Freight', 'R+L', 'Roadrunner', 'Royal Mail', 'Saia', 'SF Express', 'SFC', 'Singapore Post', 'South Eastern Freight Lines', 'Streamlite', 'UPS', 'UPS Freight', 'UPS Mail Innovations', 'Urban Express', 'USPS', 'WanbExpress', 'Watkins and Shepard', 'YANWEN', 'Yellow Freight', 'Yun Express', 'Other'\",\n    \"shipped_date\": {},\n    \"tracking_number\": \"string\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://api.feedamp.feedonomics.com/api/v2/orders/109872189273617283/fulfillments/109872189273617283', [
  'body' => '{
  "fulfillment_type": "shipment",
  "shipment": {
    "carrier": " \'4PX\', \'A-1\', \'AAA Cooper\', \'ABF\', \'Asendia\', \'Best Buy\', \'Blue Package\', \'Canada Post\', \'CEVA\', \'China Post\', \'Conway\', \'DHL\', \'DHL eCommerce\', \'Estes\', \'FedEx\', \'Fedex Freight\', \'FedEx SmartPost\', \'First Mile\', \'Hongkong Post\', \'Hunter Logistics\', \'India Post\', \'JCEX\', \'Lasership\', \'Newgistics\', \'Old Dominion\', \'OnTrac\', \'OSM\', \'Pilot Freight\', \'R+L\', \'Roadrunner\', \'Royal Mail\', \'Saia\', \'SF Express\', \'SFC\', \'Singapore Post\', \'South Eastern Freight Lines\', \'Streamlite\', \'UPS\', \'UPS Freight\', \'UPS Mail Innovations\', \'Urban Express\', \'USPS\', \'WanbExpress\', \'Watkins and Shepard\', \'YANWEN\', \'Yellow Freight\', \'Yun Express\', \'Other\'",
    "shipped_date": {},
    "tracking_number": "string"
  }
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'client' => '1',
    'token' => 'token',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.feedamp.feedonomics.com/api/v2/orders/109872189273617283/fulfillments/109872189273617283");
var request = new RestRequest(Method.PUT);
request.AddHeader("client", "1");
request.AddHeader("token", "token");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"fulfillment_type\": \"shipment\",\n  \"shipment\": {\n    \"carrier\": \" '4PX', 'A-1', 'AAA Cooper', 'ABF', 'Asendia', 'Best Buy', 'Blue Package', 'Canada Post', 'CEVA', 'China Post', 'Conway', 'DHL', 'DHL eCommerce', 'Estes', 'FedEx', 'Fedex Freight', 'FedEx SmartPost', 'First Mile', 'Hongkong Post', 'Hunter Logistics', 'India Post', 'JCEX', 'Lasership', 'Newgistics', 'Old Dominion', 'OnTrac', 'OSM', 'Pilot Freight', 'R+L', 'Roadrunner', 'Royal Mail', 'Saia', 'SF Express', 'SFC', 'Singapore Post', 'South Eastern Freight Lines', 'Streamlite', 'UPS', 'UPS Freight', 'UPS Mail Innovations', 'Urban Express', 'USPS', 'WanbExpress', 'Watkins and Shepard', 'YANWEN', 'Yellow Freight', 'Yun Express', 'Other'\",\n    \"shipped_date\": {},\n    \"tracking_number\": \"string\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "client": "1",
  "token": "token",
  "Content-Type": "application/json"
]
let parameters = [
  "fulfillment_type": "shipment",
  "shipment": [
    "carrier": " '4PX', 'A-1', 'AAA Cooper', 'ABF', 'Asendia', 'Best Buy', 'Blue Package', 'Canada Post', 'CEVA', 'China Post', 'Conway', 'DHL', 'DHL eCommerce', 'Estes', 'FedEx', 'Fedex Freight', 'FedEx SmartPost', 'First Mile', 'Hongkong Post', 'Hunter Logistics', 'India Post', 'JCEX', 'Lasership', 'Newgistics', 'Old Dominion', 'OnTrac', 'OSM', 'Pilot Freight', 'R+L', 'Roadrunner', 'Royal Mail', 'Saia', 'SF Express', 'SFC', 'Singapore Post', 'South Eastern Freight Lines', 'Streamlite', 'UPS', 'UPS Freight', 'UPS Mail Innovations', 'Urban Express', 'USPS', 'WanbExpress', 'Watkins and Shepard', 'YANWEN', 'Yellow Freight', 'Yun Express', 'Other'",
    "shipped_date": [],
    "tracking_number": "string"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.feedamp.feedonomics.com/api/v2/orders/109872189273617283/fulfillments/109872189273617283")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```